%define section		free

%ifarch %{ix86} x86_64 ppc ia64
%define bootstrap	0
%else
%define bootstrap	1
%endif

# custom and bootstrap are incompatible; enable only one or the other.
%{!?custom:	%define custom 0}
%{!?gcjprefix: 	%define gcjprefix %{nil}}
%{!?origin:	%{expand: %%define origin gcj%{gccsuffix}}}
%define gccsuffix	%{nil}
%define gccsoversion	6
%define priority	1420
%define	javaver		1.4.2
%define buildver	0
# the version-release string for the gcj rpms we require
%define gccver		4.0.0-0.42
%define jgcver		1.0.52

%define name		java-%{javaver}-%{origin}-compat
%define version		%{javaver}.%{buildver}
%define release 	40jpp_83rh.4
%define cname           java-%{javaver}-%{origin}
%define bcarchivever	134
%define bcfullver	1.34

%define	sdklnk		java-%{javaver}-%{origin}
%define	jrelnk		jre-%{javaver}-%{origin}
%define	sdkdir		%{cname}-%{version}
%define	jredir		%{sdkdir}/jre
%define sdkbindir	%{_jvmdir}/%{sdklnk}/bin
%define jrebindir	%{_jvmdir}/%{jrelnk}/bin
%define jvmjardir       %{_jvmjardir}/%{cname}-%{version}

Name:		%{name}
Version:	%{version}
Release: 	%{release}
Epoch:		0
Summary:	JPackage runtime scripts for GCJ

Group:		Development/Languages
License:	GPL
URL:		ftp://sources.redhat.com/pub/rhug/java-gcj-compat
Source0:        java-gcj-compat-%{jgcver}.tar.gz
Source1:        bcprov-jdk14-%{bcarchivever}-FEDORA.tar.gz
Source2:	eclipse-ecj-3.1.0_fc-12.jar
Source3:	ecj.sh.in
BuildRoot:	%{_tmppath}/%{name}-buildroot
BuildRequires:	jpackage-utils >= 0:1.5, sed
BuildRequires:	gcc%{gccsuffix}-java >= %{gccver}
BuildRequires:	gjdoc
BuildRequires:	libgcj%{gccsuffix}-src >= %{gccver}
BuildRequires:	libgcj%{gccsuffix} >= %{gccver}
%if ! %{bootstrap}
BuildRequires:	eclipse-ecj
%endif
Requires:	libgcj%{gccsuffix} >= %{gccver}
Requires:	gjdoc
Requires:	jessie >= 1.0.1
Requires:	gnu-crypto >= 0:2.1.0
# SASL and JCE are provided by libgcj.
Obsoletes:	gnu-crypto-sasl-jdk1.4
Obsoletes:	gnu-crypto-jce-jdk1.4
Requires:	jpackage-utils >= 0:1.6.6-1jpp_1rh
Requires(post): jpackage-utils >= 0:1.6.6-1jpp_1rh
Requires(postun): jpackage-utils >= 0:1.6.6-1jpp_1rh
Requires(post): libgcj%{gccsuffix} >= %{gccver}
Requires(postun): libgcj%{gccsuffix} >= %{gccver}
Provides:	jre-%{javaver}-%{origin} = %{epoch}:%{version}-%{release}
Provides:	jre-%{origin} = %{epoch}:%{version}-%{release}
Provides:	jre-%{javaver}, java-%{javaver}, jre = %{javaver}
Provides:	java-%{origin} = %{epoch}:%{version}-%{release}
Provides:	java = %{javaver}
Provides:	jaxp_parser_impl
Provides:	jndi, jdbc-stdext, jaas, jsse
Provides:	java-gcj-compat = %{jgcver}
# SASL and JCE are provided by libgcj.
Provides:	java-sasl
Provides:	jce
Obsoletes:	java-1.4.2-gcj4-compat <= 1.4.2.0-4jpp_2rh
PreReq:		chkconfig
%if %{custom}
# prevent autogeneration of libjawt.so dependencies
AutoReqProv:    no
%endif

%description
This package installs directory structures, shell scripts and symbolic
links to simulate a JPackage-compatible runtime environment with GCJ.

%package devel
Summary:	JPackage development scripts for GCJ
Group:		Development/Tools
Requires:	/usr/sbin/update-alternatives
Provides:       java-sdk-%{javaver}-%{origin} = %{epoch}:%{version}
Provides:	java-sdk-%{javaver}
Provides:       java-sdk-%{origin} = %{epoch}:%{version}
Provides:	java-sdk = %{javaver}
Provides:       java-%{javaver}-devel
Provides:	java-devel-%{origin} = %{epoch}:%{version}
Provides:       java-devel = %{javaver}
Provides:	java-gcj-compat-devel = %{jgcver}
Requires:	%{name} = %{epoch}:%{version}-%{release}
%if %{bootstrap}
Obsoletes:	ecj
%else
Requires:	eclipse-ecj
%endif
Requires:	python
Requires:	gcc%{gccsuffix}-java >= %{gccver}
Obsoletes:	java-1.4.2-gcj4-compat-devel <= 1.4.2.0-4jpp_2rh

%description devel
This package installs directory structures, shell scripts and symbolic
links to simulate a JPackage-compatible development environment with
GCJ.

%package src
Summary:	Source files for libgcj
Group:		Development/Libraries
Requires:	%{name} = %{epoch}:%{version}-%{release}
Requires:	libgcj%{gccsuffix}-src >= %{gccver}

%description src
This package installs a versionless src.zip symlink that points to a
specific version of the libgcj sources.

%package javadoc
Summary:	API documentation for libgcj
Group:		Development/Documentation
Requires:	%{name} = %{epoch}:%{version}-%{release}
Provides:	java-javadoc = %{epoch}:%{version}-%{release}
Provides:	java-%{javaver}-javadoc = %{epoch}:%{version}-%{release}

%description javadoc
This package installs Javadoc API documentation for libgcj.

%prep
%setup -q -n java-gcj-compat-%{jgcver}

%build
%if %{custom}
export PATH=%{gcj_prefix}/bin:$PATH
%endif
%configure --disable-symlinks --with-arch-directory=%{_arch} \
  --with-os-directory=linux \
%if %{custom}
  --with-origin-name=%{origin} \
%endif
  --with-classpath-security=%{_prefix}/lib/security/classpath.security \
  --with-security-directory=%{_sysconfdir}/java/security/security.d
make

%if %{custom}
cp -a %{SOURCE2} eclipse-ecj-%{cname}.jar
sed 's:@JAVADIR@:%{_javadir}:g' < %{SOURCE3} > ecj-1
sed 's:eclipse-ecj.jar:eclipse-ecj-%{cname}.jar:g' < ecj-1 > ecj-2
LIBGCJ_JAR="%{gcj_prefix}/share/java/libgcj-`gij%{gccsuffix} --version | head -n 2 | tail -n 1 | awk '{ print $5 }'`.jar"
sed "s,compiler.batch.Main,compiler.batch.Main -bootclasspath $LIBGCJ_JAR,g" < ecj-2 > ecj-%{cname}
%endif

%if %{bootstrap}
mkdir tmp
cp -a %{SOURCE2} eclipse-ecj.jar
mv eclipse-ecj.jar tmp
# close your eyes...
RPM_BUILD_ROOT=tmp python aot-compile-rpm
mv tmp/eclipse-ecj.jar tmp%{_libdir}/gcj/%{name}/* .
# (you can open them again now)
sed 's:@JAVADIR@:%{_javadir}:g' < %{SOURCE3} > ecj
%endif

gzip -dc %{SOURCE1} | tar -xf -

mkdir bcprov-jdk14-%{bcarchivever}/src

# build bouncy castle provider
pushd bcprov-jdk14-%{bcarchivever}/src
  unzip ../src.zip
  find -type d -name test | xargs rm -rf
%if %{bootstrap}
  gij -cp .:%{SOURCE2} org.eclipse.jdt.internal.compiler.batch.Main -bootclasspath %{_javadir}/libgcj-`gij%{gccsuffix} --version | head -n 2 | tail -n 1 | awk '{ print $5 }'`.jar `find . -type f -name "*.java"`
%else
  ecj `find . -type f -name "*.java"`
%endif
  jar2="bcprov-%{bcfullver}.jar"
  files="`find . -type f -name "*.class"`"
  test ! -d classes && mf="" || mf="`find classes/ -type f -name "*.mf" 2>/dev/null`"
  test -n "$mf" && fastjar cvfm $jar2 $mf $files || fastjar cvf $jar2 $files

  %if ! %{bootstrap}
  # natively compile BouncyCastle
  mkdir bctmp
  mv bcprov-%{bcfullver}.jar bctmp
  # close your eyes...
  RPM_BUILD_ROOT=bctmp python ../../aot-compile-rpm
  mv bctmp/bcprov-%{bcfullver}.jar bctmp%{_libdir}/gcj/%{name}/* ../..
  # (you can open them again now)
  %else
  mv bcprov-%{bcfullver}.jar ../..
  %endif
popd

%install
%if %{custom}
export PATH=%{gcj_prefix}/bin:$PATH
%endif
rm -rf $RPM_BUILD_ROOT

make DESTDIR=$RPM_BUILD_ROOT install

%if %{custom}
rm -f $RPM_BUILD_ROOT%{_bindir}/aot-compile-rpm
rm -f $RPM_BUILD_ROOT%{_bindir}/rebuild-gcj-db
%endif

%if %{custom}
ln -sf %{_bindir}/ecj-%{cname} $RPM_BUILD_ROOT%{_jvmdir}/%{sdkdir}/bin/javac
%endif

# create extensions symlinks
# jessie
ln -s %{_javadir}/jsse.jar $RPM_BUILD_ROOT%{_jvmdir}/%{jredir}/lib/jsse.jar

# extensions handling
install -dm 755 $RPM_BUILD_ROOT%{jvmjardir}
pushd $RPM_BUILD_ROOT%{jvmjardir}
   ln -s %{_jvmdir}/%{jredir}/lib/jaas.jar jaas-%{version}.jar
   ln -s %{_jvmdir}/%{jredir}/lib/jdbc-stdext.jar jdbc-stdext-%{version}.jar
   ln -s %{_jvmdir}/%{jredir}/lib/jndi.jar jndi-%{version}.jar
   ln -s %{_jvmdir}/%{jredir}/lib/jsse.jar jsse-%{version}.jar
   for jar in *-%{version}.jar ; do
     ln -sf ${jar} $(echo $jar | sed "s|-%{version}.jar|-%{javaver}.jar|g")
     ln -sf ${jar} $(echo $jar | sed "s|-%{version}.jar|.jar|g")
   done
popd

# security directories
install -dm 755 $RPM_BUILD_ROOT%{_jvmdir}/%{jredir}/lib/security

# default security provider, provided by libgcj
install -dm 755 $RPM_BUILD_ROOT%{_sysconfdir}/java/security/security.d
%if ! %{custom}
touch $RPM_BUILD_ROOT%{_sysconfdir}/java/security/security.d/1000-gnu.java.security.provider.Gnu
%endif
touch $RPM_BUILD_ROOT%{_sysconfdir}/java/security/security.d/2000-org.bouncycastle.jce.provider.BouncyCastleProvider

# versionless symlinks
pushd $RPM_BUILD_ROOT%{_jvmdir}
   ln -s %{jredir} %{jrelnk}
   ln -s %{sdkdir} %{sdklnk}
popd

pushd $RPM_BUILD_ROOT%{_jvmjardir}
   ln -s %{sdkdir} %{jrelnk}
   ln -s %{sdkdir} %{sdklnk}
popd

# generate file lists
find $RPM_BUILD_ROOT%{_jvmdir}/%{jredir} -type d \
  | sed 's|'$RPM_BUILD_ROOT'|%dir |' >  %{name}-%{version}-all.files
find $RPM_BUILD_ROOT%{_jvmdir}/%{jredir} -type f -o -type l \
  | sed 's|'$RPM_BUILD_ROOT'||'      >> %{name}-%{version}-all.files

cat %{name}-%{version}-all.files \
  > %{name}-%{version}.files

find $RPM_BUILD_ROOT%{_jvmdir}/%{sdkdir}/bin -type f -o -type l \
  | sed "s|^$RPM_BUILD_ROOT||"      > %{name}-%{version}-sdk-bin.files

# install bouncy castle provider
install -dm 755 $RPM_BUILD_ROOT%{_javadir}/gcj-endorsed
install -pm 644 bcprov-%{bcfullver}.jar \
  $RPM_BUILD_ROOT%{_javadir}/bcprov-%{bcfullver}.jar
pushd $RPM_BUILD_ROOT%{_javadir}
  ln -sf bcprov-%{bcfullver}.jar bcprov.jar
popd
pushd $RPM_BUILD_ROOT%{_javadir}/gcj-endorsed
  ln -sf %{_javadir}/bcprov-%{bcfullver}.jar bcprov-%{bcfullver}.jar
popd
%if ! %{bootstrap}
mkdir -p $RPM_BUILD_ROOT%{_libdir}/gcj/%{name}
install -m755 bcprov-%{bcfullver}.jar.so $RPM_BUILD_ROOT%{_libdir}/gcj/%{name}
install -m644 bcprov-%{bcfullver}.jar.db $RPM_BUILD_ROOT%{_libdir}/gcj/%{name}
%endif

# classmap database directory
install -dm 755 $RPM_BUILD_ROOT%{_libdir}/gcj

%if %{custom}
mkdir -p $RPM_BUILD_ROOT%{_javadir}
install -m644 eclipse-ecj-%{cname}.jar $RPM_BUILD_ROOT%{_javadir}
mkdir -p $RPM_BUILD_ROOT%{_bindir}
install -m755 ecj-%{cname} $RPM_BUILD_ROOT%{_bindir}
%endif

%if %{bootstrap}
mkdir -p $RPM_BUILD_ROOT%{_javadir}
install -m644 eclipse-ecj.jar $RPM_BUILD_ROOT%{_javadir}
mkdir -p $RPM_BUILD_ROOT%{_libdir}/gcj/%{name}
install -m755 eclipse-ecj.jar.so $RPM_BUILD_ROOT%{_libdir}/gcj/%{name}
install -m644 eclipse-ecj.jar.db $RPM_BUILD_ROOT%{_libdir}/gcj/%{name}
mkdir -p $RPM_BUILD_ROOT%{_bindir}
install -m755 ecj $RPM_BUILD_ROOT%{_bindir}
%endif

# build and install api documentation
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
touch $RPM_BUILD_ROOT%{_javadocdir}/{%{name},java}
mkdir docsbuild
pushd docsbuild
# work around ppc64 file system corruption
  if unzip -tq /usr/share/java/src-4.1.0.zip
  then
    fastjar xvf /usr/share/java/src-`gij%{gccsuffix} --version | head -n 2 | tail -n 1 | awk '{ print $5 }'`.zip
    rm -rf gnu
    find ./ -name \*.java | xargs -n 1 dirname | sort | uniq | sed -e "s/\.\///" | sed -e "s/\//\./" | \
      sed -e "s/\//\./" | sed -e "s/\//\./" | sed -e "s/\//\./" | sed -e "s/\//\./" | \
      xargs gjdoc -d $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version} -encoding UTF-8 -breakiterator -licensetext \
        -linksource -splitindex -doctitle "GNU libgcj `gij%{gccsuffix} --version | head -n 2 | tail -n 1 | awk '{ print $5 }'`" \
        -windowtitle "GNU libgcj `gij%{gccsuffix} --version | head -n 2 | tail -n 1 | awk '{ print $5 }'` Documentation"
  else
    touch $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/package-list
  fi
popd

%ifarch x86_64
ln -s %{_jvmdir}/%{jredir}/lib/%{_arch} \
  $RPM_BUILD_ROOT%{_jvmdir}/%{jredir}/lib/amd64
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post

%if %{custom}
export PATH=%{gcj_prefix}/bin:$PATH
%endif

update-alternatives \
  --install %{_bindir}/java java %{jrebindir}/java %{priority} \
  --slave %{_jvmdir}/jre          jre          %{_jvmdir}/%{jrelnk} \
  --slave %{_jvmjardir}/jre       jre_exports  %{_jvmjardir}/%{jrelnk} \
  --slave %{_bindir}/rmiregistry  rmiregistry  %{jrebindir}/rmiregistry

update-alternatives \
  --install %{_jvmdir}/jre-%{origin} \
      jre_%{origin} %{_jvmdir}/%{jrelnk} %{priority} \
  --slave %{_jvmjardir}/jre-%{origin} \
      jre_%{origin}_exports %{_jvmjardir}/%{jrelnk}

update-alternatives \
  --install %{_jvmdir}/jre-%{javaver} \
      jre_%{javaver} %{_jvmdir}/%{jrelnk} %{priority} \
  --slave %{_jvmjardir}/jre-%{javaver} \
      jre_%{javaver}_exports %{_jvmjardir}/%{jrelnk}

# rt.jar
ln -sf \
  %{_javadir}/libgcj-`gij%{gccsuffix} --version | head -n 2 | tail -n 1 | awk '{ print $5 }'`.jar \
  %{_jvmdir}/%{cname}-%{version}/jre/lib/rt.jar

# jaas.jar
ln -sf \
  %{_javadir}/libgcj-`gij%{gccsuffix} --version | head -n 2 | tail -n 1 | awk '{ print $5 }'`.jar \
  %{_jvmdir}/%{cname}-%{version}/jre/lib/jaas.jar

# jdbc-stdext.jar
ln -sf \
  %{_javadir}/libgcj-`gij%{gccsuffix} --version | head -n 2 | tail -n 1 | awk '{ print $5 }'`.jar \
  %{_jvmdir}/%{cname}-%{version}/jre/lib/jdbc-stdext.jar

# jndi.jar
ln -sf \
  %{_javadir}/libgcj-`gij%{gccsuffix} --version | head -n 2 | tail -n 1 | awk '{ print $5 }'`.jar \
  %{_jvmdir}/%{cname}-%{version}/jre/lib/jndi.jar

# java.security
ln -sf \
  %{_prefix}/lib/security/classpath.security \
  %{_jvmdir}/%{cname}-%{version}/jre/lib/security/java.security

if [ -x %{_bindir}/rebuild-security-providers ]
then
  %{_bindir}/rebuild-security-providers
fi

%if %{custom}
# jaxp_parser_impl
update-alternatives --install %{_javadir}/jaxp_parser_impl.jar \
  jaxp_parser_impl \
  %{gcj_prefix}/share/java/libgcj-`gij%{gccsuffix} --version | head -n 2 | tail -n 1 | awk '{ print $5 }'`.jar 20
%else
# jaxp_parser_impl
update-alternatives --install %{_javadir}/jaxp_parser_impl.jar \
  jaxp_parser_impl \
  %{_javadir}/libgcj-`gij%{gccsuffix} --version | head -n 2 | tail -n 1 | awk '{ print $5 }'`.jar 20
%endif

if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi

%post devel

%if %{custom}
export PATH=%{gcj_prefix}/bin:$PATH
%endif

update-alternatives \
  --install %{_bindir}/javac javac %{sdkbindir}/javac %{priority} \
  --slave %{_jvmdir}/java     java_sdk          %{_jvmdir}/%{sdklnk} \
  --slave %{_jvmjardir}/java  java_sdk_exports  %{_jvmjardir}/%{sdklnk} \
  --slave %{_bindir}/javadoc  javadoc           %{sdkbindir}/javadoc \
  --slave %{_bindir}/javah    javah             %{sdkbindir}/javah \
  --slave %{_bindir}/jar      jar               %{sdkbindir}/jar \
  --slave %{_bindir}/rmic     rmic              %{sdkbindir}/rmic

update-alternatives \
  --install %{_jvmdir}/java-%{origin} \
      java_sdk_%{origin} %{_jvmdir}/%{sdklnk} %{priority} \
  --slave %{_jvmjardir}/java-%{origin} \
      java_sdk_%{origin}_exports %{_jvmjardir}/%{sdklnk}

update-alternatives \
  --install %{_jvmdir}/java-%{javaver} \
      java_sdk_%{javaver} %{_jvmdir}/%{sdklnk} %{priority} \
  --slave %{_jvmjardir}/java-%{javaver} \
      java_sdk_%{javaver}_exports %{_jvmjardir}/%{sdklnk}

# jni.h
ln -sf \
  `gcj%{gccsuffix} -print-file-name=include/jni.h` \
  %{_jvmdir}/%{cname}-%{version}/include/jni.h

# jni_md.h
ln -sf \
  `gcj%{gccsuffix} -print-file-name=include/jni_md.h` \
  %{_jvmdir}/%{cname}-%{version}/include/linux/jni_md.h

# jawt.h
ln -sf \
  `gcj%{gccsuffix} -print-file-name=include/jawt.h` \
  %{_jvmdir}/%{cname}-%{version}/include/jawt.h

# jawt_md.h
ln -sf \
  `gcj%{gccsuffix} -print-file-name=include/jawt_md.h` \
  %{_jvmdir}/%{cname}-%{version}/include/linux/jawt_md.h

%post src

%if %{custom}
export PATH=%{gcj_prefix}/bin:$PATH
%endif

# src.zip
ln -sf \
  %{_javadir}/src-`gcj%{gccsuffix} --version | head -n 1 | awk '{ print $3 }'`.zip \
  %{_jvmdir}/%{cname}-%{version}/src.zip

%post javadoc
{
  rm -f %{_javadocdir}/%{name} %{_javadocdir}/java
  ln -sf %{name}-%{version} %{_javadocdir}/%{name}
  ln -sf %{name}-%{version} %{_javadocdir}/java
} || :

%postun
if [ $1 -eq 0 ] ; then

%if %{custom}
export PATH=%{gcj_prefix}/bin:$PATH
%endif

   update-alternatives --remove java %{jrebindir}/java
   update-alternatives --remove jre_%{origin}  %{_jvmdir}/%{jrelnk}
   update-alternatives --remove jre_%{javaver} %{_jvmdir}/%{jrelnk}
%if %{custom}
   update-alternatives --remove jaxp_parser_impl \
     %{gcj_prefix}/share/java/libgcj-`gij%{gccsuffix} --version | head -n 2 | tail -n 1 | awk '{ print $5 }'`.jar
%else
   update-alternatives --remove jaxp_parser_impl \
     %{_javadir}/libgcj-`gij%{gccsuffix} --version | head -n 2 | tail -n 1 | awk '{ print $5 }'`.jar
%endif
fi

if [ -x %{_bindir}/rebuild-security-providers ]
then
  %{_bindir}/rebuild-security-providers
fi

if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi

%postun devel
if [ $1 -eq 0 ] ; then

%if %{custom}
export PATH=%{gcj_prefix}/bin:$PATH
%endif

   update-alternatives --remove javac %{sdkbindir}/javac
   update-alternatives --remove java_sdk_%{origin}  %{_jvmdir}/%{sdklnk}
   update-alternatives --remove java_sdk_%{javaver} %{_jvmdir}/%{sdklnk}
fi

%triggerin -- libgcj%{gccsuffix} > %{gccver}
{

%if %{custom}
export PATH=%{gcj_prefix}/bin:$PATH
%endif

  # rt.jar
  ln -sf \
    %{_javadir}/libgcj-`gij%{gccsuffix} --version | head -n 2 | tail -n 1 | awk '{ print $5 }'`.jar \
    %{_jvmdir}/%{cname}-%{version}/jre/lib/rt.jar

  # jaas.jar
  ln -sf \
    %{_javadir}/libgcj-`gij%{gccsuffix} --version | head -n 2 | tail -n 1 | awk '{ print $5 }'`.jar \
    %{_jvmdir}/%{cname}-%{version}/jre/lib/jaas.jar

  # jdbc-stdext.jar
  ln -sf \
    %{_javadir}/libgcj-`gij%{gccsuffix} --version | head -n 2 | tail -n 1 | awk '{ print $5 }'`.jar \
    %{_jvmdir}/%{cname}-%{version}/jre/lib/jdbc-stdext.jar

  # jndi.jar
  ln -sf \
    %{_javadir}/libgcj-`gij%{gccsuffix} --version | head -n 2 | tail -n 1 | awk '{ print $5 }'`.jar \
    %{_jvmdir}/%{cname}-%{version}/jre/lib/jndi.jar

%if %{custom}
  # jaxp_parser_impl
  update-alternatives --install %{_javadir}/jaxp_parser_impl.jar \
    jaxp_parser_impl \
    %{gcj_prefix}/share/java/libgcj-`gij%{gccsuffix} --version | head -n 2 | tail -n 1 | awk '{ print $5 }'`.jar 20
%else
  # jaxp_parser_impl
  update-alternatives --install %{_javadir}/jaxp_parser_impl.jar \
    jaxp_parser_impl \
    %{_javadir}/libgcj-`gij%{gccsuffix} --version | head -n 2 | tail -n 1 | awk '{ print $5 }'`.jar 20
%endif
} || :

# gcc-java requires libgcj-devel which provides jni.h
%triggerin devel -- gcc%{gccsuffix}-java > %{gccver}
{

%if %{custom}
export PATH=%{gcj_prefix}/bin:$PATH
%endif

  # jni.h
  ln -sf \
    `gcj%{gccsuffix} -print-file-name=include/jni.h` \
    %{_jvmdir}/%{cname}-%{version}/include/jni.h

  # jni_md.h
  ln -sf \
    `gcj%{gccsuffix} -print-file-name=include/jni_md.h` \
    %{_jvmdir}/%{cname}-%{version}/include/jni_md.h

  # jawt.h
  ln -sf \
    `gcj%{gccsuffix} -print-file-name=include/jawt.h` \
    %{_jvmdir}/%{cname}-%{version}/include/jawt.h

  # jawt_md.h
  ln -sf \
    `gcj%{gccsuffix} -print-file-name=include/jawt_md.h` \
    %{_jvmdir}/%{cname}-%{version}/include/linux/jawt_md.h
} || :

%triggerin src -- libgcj%{gccsuffix}-src >= %{gccver}
{

%if %{custom}
export PATH=%{gcj_prefix}/bin:$PATH
%endif

  ln -sf \
    %{_javadir}/src-`gcj%{gccsuffix} --version | head -n 1 | awk '{ print $3 }'`.zip \
    %{_jvmdir}/%{cname}-%{version}/src.zip
} || :

%files -f %{name}-%{version}.files
%defattr(-,root,root,-)
%dir %{_libdir}/gcj
%doc
%dir %{_jvmdir}/%{sdkdir}
%dir %{jvmjardir}
%if ! %{custom}
%{_bindir}/rebuild-gcj-db
%endif
%{jvmjardir}/*.jar
%{_jvmdir}/%{jrelnk}
%{_jvmjardir}/%{jrelnk}
# %{_jvmprivdir}/*
%if ! %{custom}
%{_sysconfdir}/java/security/security.d/1000-gnu.java.security.provider.Gnu
%endif
%{_javadir}/bcprov.jar
%{_javadir}/bcprov-%{bcfullver}.jar
%{_javadir}/gcj-endorsed/bcprov-%{bcfullver}.jar
%{_sysconfdir}/java/security/security.d/2000-org.bouncycastle.jce.provider.BouncyCastleProvider
%ifarch x86_64
%{_jvmdir}/%{jredir}/lib/amd64
%endif
%if ! %{bootstrap}
%attr(-,root,root) %{_libdir}/gcj/%{name}
%endif

%files devel -f %{name}-%{version}-sdk-bin.files
%defattr(-,root,root)
%doc
%dir %{_jvmdir}/%{sdkdir}/bin
%if ! %{custom}
%{_bindir}/aot-compile-rpm
%endif
%{_jvmdir}/%{sdkdir}/lib
%{_jvmdir}/%{sdkdir}/include
%{_jvmdir}/%{sdklnk}
%{_jvmjardir}/%{sdklnk}
%if %{custom}
%{_bindir}/ecj-%{cname}
%{_javadir}/eclipse-ecj-%{cname}.jar
%endif
%if %{bootstrap}
%{_bindir}/ecj
%{_libdir}/gcj/%{name}
%{_javadir}/eclipse-ecj.jar
%endif

%files src
%defattr(-,root,root)

%files javadoc
%defattr(-,root,root)
%doc %{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}
%ghost %doc %{_javadocdir}/java

%changelog
* Mon Dec 11 2006 Thomas Fitzsimmons <fitzsim@redhat.com> - 0:1.4.2.0-40jpp_83rh.4
- Install bcprov jar and unversioned symlink in %{_javadir}.
- Install bcprov symlink in %{_javadir}/gcj-endorsed.
- Related: rhbz#218794

* Tue Nov 28 2006 Thomas Fitzsimmons <fitzsim@redhat.com> - 0:1.4.2.0-40jpp_83rh.3
- Remove IDEA algorithm.

* Tue Nov 28 2006 Thomas Fitzsimmons <fitzsim@redhat.com> - 0:1.4.2.0-40jpp_83rh.2
- Import Bouncy Castle 1.34.
- Unzip bundled src.zip.
- Remove X962NamedCurves patch.

* Wed Jul 26 2006 Thomas Fitzsimmons <fitzsim@redhat.com> - 0:1.4.2.0-40jpp_83rh.1
- Add eclipse-ecj build requires on non-bootstrap architectures.
- Remove ifnarch ia64 sections.
- Fix BouncyCastle bug. (200196)

* Fri Mar  3 2006 Thomas Fitzsimmons <fitzsim@redhat.com> - 0:1.4.2.0-40jpp_83rh
- Make javadoc post scriplet pass unconditionally.
- Force symlinks in javadoc post scriptlet.

* Wed Mar  1 2006 Thomas Fitzsimmons <fitzsim@redhat.com> - 0:1.4.2.0-40jpp_82rh
- Add chkconfig as a prerequisite.

* Wed Mar  1 2006 Thomas Fitzsimmons <fitzsim@redhat.com> - 0:1.4.2.0-40jpp_81rh
- Natively compile BouncyCastle.
- Move bcprov in the build section so that it is found by bootstrap
  architectures in the install section.
- Only include BC library directory on non-boostrap architectures.

* Fri Feb 10 2006 Jesse Keating <jkeating@redhat.com> - 0:1.4.2.0-40jpp_80rh
- bump again for double-long bug on ppc(64)

* Fri Feb 10 2006 Thomas Fitzsimmons <fitzsim@redhat.com> - 0:1.4.2.0-40jpp_79rh
- Install compatibility amd64 symlink.

* Wed Feb  8 2006 Thomas Fitzsimmons <fitzsim@redhat.com> - 0:1.4.2.0-40jpp_78rh
- Install javadocs in versioned directory.

* Tue Feb 07 2006 Jesse Keating <jkeating@redhat.com> - 0:1.4.2.0-40jpp_77rh
- rebuilt for new gcc4.1 snapshot and glibc changes

* Mon Feb  6 2006 Thomas Fitzsimmons <fitzsim@redhat.com> - 0:1.4.2.0-40jpp_76rh
- Test src.zip before extracting its contents.

* Mon Feb  6 2006 Thomas Fitzsimmons <fitzsim@redhat.com> - 0:1.4.2.0-40jpp_75rh
- Use fastjar to extract libgcj sources instead of unzip.

* Mon Feb  6 2006 Thomas Fitzsimmons <fitzsim@redhat.com> - 0:1.4.2.0-40jpp_74rh
- Require gjdoc and libgcj-src packages for build.
- Build API documentation.
- Add -javadoc package.

* Thu Feb  2 2006 Thomas Fitzsimmons <fitzsim@redhat.com> - 0:1.4.2.0-40jpp_73rh
- Adjust Jessie and GNU Crypto version requirements.
- Uncomment ifnarch ia64 sections.

* Thu Feb  2 2006 Thomas Fitzsimmons <fitzsim@redhat.com> - 0:1.4.2.0-40jpp_71rh
- Obsolete gnu-crypto-sasl-jdk1.4 and gnu-crypto-jce-jdk1.4 regardless of versions.

* Thu Feb  2 2006 Thomas Fitzsimmons <fitzsim@redhat.com> - 0:1.4.2.0-40jpp_70rh
- Remove all ifnarch ia64 sections.

* Thu Feb  2 2006 Thomas Fitzsimmons <fitzsim@redhat.com> - 0:1.4.2.0-40jpp_69rh
- Don't call aot-compile-rpm on bootstrap architectures.

* Thu Feb  2 2006 Thomas Fitzsimmons <fitzsim@redhat.com> - 0:1.4.2.0-40jpp_68rh
- Obsolete gnu-crypto-sasl-jdk1.4 and gnu-crypto-jce-jdk1.4.
- Provide java-sasl and jce.

* Thu Feb  2 2006 Thomas Fitzsimmons <fitzsim@redhat.com> - 0:1.4.2.0-40jpp_67rh
- Remove conditional BuildRequires, which isn't supported by beehive.

* Thu Feb  2 2006 Thomas Fitzsimmons <fitzsim@redhat.com> - 0:1.4.2.0-40jpp_66rh
- Fix ecj script location when building BouncyCastle in bootstrap mode.
- Do not BuildRequires eclipse-ecj in bootstrap mode.
- Build BouncyCastle with bootstrap ecj script in bootstrap mode.

* Fri Jan 27 2006 Thomas Fitzsimmons <fitzsim@redhat.com> - 0:1.4.2.0-40jpp_64rh
- Import BouncyCastle 1.3.1.
- Re-enable BouncyCastle provider.

* Wed Jan 25 2006 Thomas Fitzsimmons <fitzsim@redhat.com> - 0:1.4.2.0-40jpp_63rh
- Import java-gcj-compat 1.0.52.

* Mon Jan 16 2006 Thomas Fitzsimmons <fitzsim@redhat.com> - 0:1.4.2.0-40jpp_62rh
- Remove aot-compile-rpm and rebuild-gcj-db when building a custom RPM.
- Import java-gcj-compat 1.0.51.

* Mon Jan  9 2006 Archit Shah <ashah@redhat.com> - 0:1.4.2.0-40jpp_61rh
- Import java-gcj-compat 1.0.50.

* Fri Jan  6 2006 Archit Shah <ashah@redhat.com> - 0:1.4.2.0-40jpp_60rh
- Import java-gcj-compat 1.0.48.

* Wed Jan  4 2006 Thomas Fitzsimmons <fitzsim@redhat.com> - 0:1.4.2.0-40jpp_59rh
- Import java-gcj-compat 1.0.47.

* Wed Jan  4 2006 Thomas Fitzsimmons <fitzsim@redhat.com> - 0:1.4.2.0-40jpp_58rh
- Import java-gcj-compat 1.0.46.

* Wed Dec 21 2005 Jesse Keating <jkeating@redhat.com> - 0:1.4.2.0-40jpp_57rh
- rebuilt again w/ another new gcc

* Fri Dec 09 2005 Jesse Keating <jkeating@redhat.com>
- rebuilt

* Wed Nov 30 2005 Thomas Fitzsimmons <fitzsim@redhat.com> - 0:1.4.2.0-40jpp_56rh
- Bump release number.

* Wed Nov 16 2005 Thomas Fitzsimmons <fitzsim@redhat.com> - 0:1.4.2.0-40jpp_55rh
- Call rebuild-security-providers conditionally on its existence.

* Tue Nov 15 2005 Archit Shah <ashah@redhat.com> 0:1.4.2.0-40jpp_54rh
- Import java-gcj-compat 1.0.45.

* Mon Nov 14 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-40jpp_53rh
- Bump release number.

* Mon Nov 14 2005 Thomas Fitzsimmons <fitzsim@redhat.com> - 0:1.4.2.0-40jpp_52rh
- Import java-gcj-compat 1.0.44.
- Make aot-compile-rpm and rebuild-gcj-db real scripts, not
  alternatives symlinks.
- Put rebuild-gcj-db in base package.

* Wed Sep 21 2005 Gary Benson <gbenson@redhat.com>  - 0:1.4.2.0-40jpp_51rh
- Import java-gcj-compat 1.0.43.

* Tue Sep 20 2005 Gary Benson <gbenson@redhat.com>  - 0:1.4.2.0-40jpp_50rh
- Import java-gcj-compat 1.0.42.

* Tue Sep  6 2005 Thomas Fitzsimmons <fitzsim@redhat.com> - 0:1.4.2.0-40jpp_49rh
- Import java-gcj-compat 1.0.41.

* Tue Sep  6 2005 Thomas Fitzsimmons <fitzsim@redhat.com> - 0:1.4.2.0-40jpp_48rh
- Don't include security provider file in custom builds.
- Don't mark security provider file as config(noreplace).

* Wed Aug 31 2005 Thomas Fitzsimmons <fitzsim@redhat.com> - 0:1.4.2.0-40jpp_47rh
- Import java-gcj-compat 1.0.40.
- Point jaxp_parser_impl at proper libgcj-<version>.jar for custom
  builds.

* Wed Aug 31 2005 Thomas Fitzsimmons <fitzsim@redhat.com> - 0:1.4.2.0-40jpp_46rh
- Don't autogenerate libjawt.so dependencies in custom builds.

* Tue Aug 30 2005 Thomas Fitzsimmons <fitzsim@redhat.com> - 0:1.4.2.0-40jpp_45rh
- Import java-gcj-compat 1.0.39.
- Remove libjawt.so symlinks.
- Symlink to jni_md.h.

* Tue Aug 30 2005 Thomas Fitzsimmons <fitzsim@redhat.com> - 0:1.4.2.0-40jpp_44rh
- Install ecj when building a custom java-1.4.2-gcj-compat.
- Fix removal of jaxp_parser_impl.jar alternative.

* Mon Aug 29 2005 Thomas Fitzsimmons <fitzsim@redhat.com> - 0:1.4.2.0-40jpp_44rh
- Import java-gcj-compat 1.0.37.
- Remove aot-compile and find-and-aot-compile.
- Make aot-compile-rpm and rebuild-gcj-db alternatives symlinks.
- Mark security file config(noreplace).

* Thu Jul 28 2005 Gary Benson <gbenson@redhat.com> 0:1.4.2.0-40jpp_43rh
- Upgrade bootstrap ecj to pick up classpath parser fix.
- Import java-gcj-compat 1.0.36.

* Fri Jul 22 2005 Gary Benson <gbenson@redhat.com> 0:1.4.2.0-40jpp_42rh
- Remove jta compatibility stuff.

* Thu Jul 21 2005 Gary Benson <gbenson@redhat.com> 0:1.4.2.0-40jpp_41rh
- Remove servletapi and jspapi now that tomcat5 is built.

* Wed Jul 20 2005 Gary Benson <gbenson@redhat.com> 0:1.4.2.0-40jpp_40rh
- Import java-gcj-compat 1.0.35.

* Tue Jul 19 2005 Gary Benson <gbenson@redhat.com> 0:1.4.2.0-40jpp_39rh
- Import java-gcj-compat 1.0.34.
- Provide servletapi and jspapi for bootstrapping.

* Thu Jul 14 2005 Gary Benson <gbenson@redhat.com> 0:1.4.2.0-40jpp_38rh
- Import java-gcj-compat 1.0.33.

* Wed Jul 13 2005 Gary Benson <gbenson@redhat.com> 0:1.4.2.0-40jpp_37rh
- Add virtual dependencies to indicate our upstream version.
- Import java-gcj-compat 1.0.32.

* Fri Jul  8 2005 Gary Benson <gbenson@redhat.com> 0:1.4.2.0-40jpp_36rh
- Replace the binary ecj with a script to work around #162748.

* Thu Jul  7 2005 Gary Benson <gbenson@redhat.com> 0:1.4.2.0-40jpp_33rh
- Bootstrap onto ia64, ppc64, s390 and s390x.
- Add python dependency for aot-compile-rpm.

* Thu Jul  7 2005 Gary Benson <gbenson@redhat.com> 0:1.4.2.0-40jpp_32rh
- Import java-gcj-compat 1.0.31.
- Move the aot-compile scripts to the devel subpackage.

* Mon Jun  6 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-40jpp_31rh
- Add jaxp_parser_impl.jar alternative. (#158751)
- Separate post and postun requires lines.
- Use gij, not gcj to compute version strings in post and triggerin sections.

* Thu May 26 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-40jpp_30rh
- Add jaxp_parser_impl.jar alternative. (#158751)

* Thu May 26 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-40jpp_29rh
- Separate post and postun requires lines

* Thu May 26 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-40jpp_28rh
- Re-remove bouncy castle provider.

* Thu May 26 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-40jpp_27rh
- Re-add bouncy castle provider. (#146782)

* Wed May 25 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-40jpp_26rh
- Import java-gcj-compat 1.0.30.

* Wed May 25 2005 Gary Benson <gbenson@redhat.com> 0:1.4.2.0-40jpp_25rh
- Update tools.jar with the ecj's new jarfile name (#158734).

* Fri May 20 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-40jpp_24rh
- Update libjawt.so symlink to reflect libgcjawt.so's new name.

* Thu May 19 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-40jpp_23rh
- Import java-gcj-compat 1.0.29.

* Wed May 18 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-40jpp_22rh
- Move gcc-java requirement from base to -devel.

* Wed May 18 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-40jpp_21rh
- Comment out bouncy castle stuff.

* Tue May 17 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-40jpp_20rh
- Require jpackage-utils for post and postun.
- Run rebuild-security-providers with full path.

* Tue May 17 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-40jpp_19rh
- Require eclipse-ecj for build.
- Include Bouncy Castle provider.
- Exclusive arch ix86, x86_64 and ppc.

* Wed May 11 2005 Andrew Overholt <overholt@redhat.com>
- Add machinery to allow for use with non-system gcc installations.

* Fri Apr 15 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-40jpp_18rh
- Require gnu-crypto.

* Fri Apr 15 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-40jpp_17rh
- Provide jaxp_parser_impl.

* Wed Apr 13 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-40jpp_16rh
- Import java-gcj-compat 1.0.28.

* Mon Apr  4 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-40jpp_15rh
- Import java-gcj-compat 1.0.27.
- Bump gccver to 4.0.0-0.39.
- Make -devel take ownership of symlinks as well as regular files.

* Wed Mar 30 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-40jpp_14rh
- Import java-gcj-compat 1.0.23.
- Always look for classpath.security in /usr/lib. (151561)
- Provide jsse. (151662)

* Thu Mar 17 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-40jpp_13rh
- Uncomment rebuild-security-providers.
- Require jessie >= 1.0.0-3.

* Tue Mar 15 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-40jpp_12rh
- Don't re-run rebuild-security-providers.

* Tue Mar 15 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-40jpp_11rh
- Add jaas and jta provides.

* Tue Mar  8 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-40jpp_10rh
- Import java-gcj-compat 1.0.22.
- Symlink jaas.jar, jdbc-stdext.jar, jndi.jar and jta.jar to
  libgcj.jar.

* Sat Mar  5 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-40jpp_9rh
- Import java-gcj-compat 1.0.21.

* Sat Mar  5 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-40jpp_8rh
- Import java-gcj-compat 1.0.20.
- Depend on jessie.
- Install jsse.jar.
- Install security directory.
- Symlink classpath.security to java.security.

* Sat Mar  5 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-40jpp_7rh
- Import java-gcj-compat 1.0.19.

* Thu Mar  3 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-40jpp_6rh
- Import java-gcj-compat 1.0.18.

* Thu Mar  3 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-40jpp_5rh
- Update descriptions.

* Wed Mar  2 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-40jpp_4rh
- Bump release number.

* Wed Mar  2 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-40jpp_3rh
- Make java-1.4.2-gcj-compat-devel obsolete java-1.4.2-gcj4-compat-devel.
- Import java-gcj-compat 1.0.17.
- Specify --with-arch-directory and --with-os-directory options on
  configure line.

* Tue Mar  1 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-40jpp_2rh
- Make arch-specific.

* Tue Mar  1 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-40jpp_1rh
- Merge java-1.4.2-gcj4-compat into java-1.4.2-gcj-compat.
- Import java-gcj-compat 1.0.15.
- Add AWT Native Interface symlinks.
- Remove build requires on eclipse-ecj.

* Thu Feb 17 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-4jpp_4rh
- Add -src sub-package.

* Wed Feb  9 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-4jpp_3rh
- Import java-gcj-compat 1.0.14.

* Tue Feb  8 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-4jpp_2rh
- Import java-gcj-compat 1.0.13.

* Mon Feb  7 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-4jpp_1rh
- Import java-gcj-compat 1.0.12.

* Wed Feb  2 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-4jpp_1rh
- Add Red Hat release number.

* Tue Feb  1 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-4jpp
- Remove gjdoc version requirement.
- Change java-gcj-compat version number.

* Tue Feb  1 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-4jpp
- Import java-gcj-compat 1.0.11.
- Require gjdoc.

* Tue Feb  1 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-4jpp
- Add jni.h symlink.
- Install rt.jar as an unmanaged symlink.
- Conflict and obsolete old java-gcj-compat rpms.
- Import java-gcj-compat 1.0.9.

* Mon Jan 24 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-3jpp
- Import java-gcj-compat 1.0.8.

* Thu Jan 13 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-2jpp
- Make jvmjardir use cname, not name.

* Wed Jan 12 2005 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.4.2.0-1jpp
- Initial build.
